/*
 * EvernoteSession.m
 * evernote-sdk-ios
 *
 * Copyright 2012 Evernote Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

var JSClipInterface = {
    
emptyIfNull: function(str){
    if(str === 'undefined' || (str == null)){
        return '';
    }
    return str;
},
    
articleReady: function(url){
    var obj = new JSBridgeObj();
	obj.addObject("name", "EFArticleReady");
	obj.addObject("url", this.emptyIfNull(url));
	obj.sendBridgeObject();
},
    
getResource: function(url){
    var obj = new JSBridgeObj();
	obj.addObject("name", "EFGetResource");
	obj.addObject("url", this.emptyIfNull(url));
	obj.sendBridgeObject();
},
    
clipDone: function(clippedText){
    var obj = new JSBridgeObj();
	obj.addObject("name", "EFClipDone");
	obj.addObject("clippedText", this.emptyIfNull(clippedText));
	obj.sendBridgeObject();
},
    
debugStartTime: function(str){
},
    
debugEndTime: function(str){
},
    
log: function(str){
    var obj = new JSBridgeObj();
	obj.addObject("name", "EFLog");
	obj.addObject("str", this.emptyIfNull(str));
	obj.sendBridgeObject();
},
    
reportException: function(e){
    try{
        str = "";
        for (var i in e) {
            str += (i + ": " + e[i] + "\n");
        }
        
        var obj = new JSBridgeObj();
        
        if(str=="undefined") str = "";
        
        obj.addObject("name", "EFException");
        obj.addObject("str", str);
        obj.sendBridgeObject();    
    }
    catch(e2){
        // no remedy here
    }
}
    
}