/*
 * EvernoteSession.m
 * evernote-sdk-ios
 *
 * Copyright 2012 Evernote Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

console.log("init is running start");
function init() {
    "use strict";
    
    console.log("init()");
    
    console.log("init() - Browser exists?" + !(typeof window.Browser === 'undefined'));
    console.log("init() - SAFARI exists?" + !(typeof SAFARI === 'undefined'));
    console.log("init() - handleResourceResponse exists?" + (typeof(Browser.handleResourceResponse) == typeof(Function)));
    console.log("init() - sendToExtension exists?" + (typeof(Browser.sendToExtension) == typeof(Function)));
    
    var domReady = false;
    var msgReady = false;
    
    function start() {
        console.log("start()");
        var checkCount = 0;
        var readyStateCheckInterval = setInterval(function() {
                                                  if ((document && (document.readyState === "complete")) ||
                                                      (checkCount > 45)) {
                                                  console.log("clip document is ready!");
                                                  startInternal();
                                                  clearInterval(readyStateCheckInterval);
                                                  } else {
                                                  console.log("clip document is NOT ready yet");
                                                  checkCount++;
                                                  }
                                                  }, 300);
        
        //clipper = new Clipper();
        //checkSimSearch();
        //startInternal();
    }
    
    function startInternal() {
        console.log("startInternal()");
        var x = document.createElement("div");
        x.id = "cssRulesCheckDiv";
        var y = document.createElement("style");
        y.innerText = "div#cssRulesCheckDiv {display:none}";
        document.body.appendChild(x);
        document.body.appendChild(y);
        
        try {
            if (typeof window.pageInfo == undefined || window.pageInfo ==null)
            {
                window.pageInfo = new PageInfo();
            }
            if (typeof window.contentPreview == undefined || window.contentPreview ==null)
            {
                window.contentPreview = new ContentPreview();
            }
            
            if (!window.jQuery) throw new Error("No jQuery!");
            window.jQueryForClearlyComponent = window.jQuery;
            var objJSBridgeLog = new JSBridgeObj();
            objJSBridgeLog.addObject("debugStartTime", "find article");
            objJSBridgeLog.sendBridgeObject();

            window.pageInfo.getDefaultArticle(function(){
                                              objJSBridgeLog.addObject("debugEndTime", "find article");
                                              objJSBridgeLog.sendBridgeObject();
                                              console.log("done finding article");
                                              });
        } catch (e){
            for (var i in e) console.log(i + ": " + e[i]);
            console.log(e);
        }
        console.log("startInternal() - article detected!");
        Browser.articleReady(document.URL);
    }
    
    console.log("after start method definition");
    
    this.start = start;
    
    //  if (SAFARI) {
    //    // Don't call this from frames.
    //    if (window && window != window.parent) return;
    //    Browser.sendToExtension({name: "main_getL10n"});
    //  }
    //  else {
    msgReady = true;
    go();
    //}
    
    //  Browser.addMessageHandlers({
    //    l10nData: msgHandlerL10n
    //  });
    
    //  window.addEventListener("DOMContentLoaded", function(){
    //    log("DomContentLoaded");
    //    domReady = true;
    //    go();
    //  });
    
    //  function msgHandlerL10n(request, sender, sendResponse) {
    //    if (request.data) {
    //      Browser.i18n._setL10nData(request.data);
    //    }
    //    msgReady = true;
    //    go();
    //  }
    
    function go() {
        if (msgReady && domReady) {
            start();
        }
    }
    
    ///Browser.runIfInTopFrame(init);
}
console.log("init is running end");

console.log("IT is working!!!");
var initFunc = new init();
initFunc.start();
