/*
 * EvernoteSession.m
 * evernote-sdk-ios
 *
 * Copyright 2012 Evernote Corporation
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

window.log = function (str) {
  //JSClipInterface.log(str);
}

window.console.log = log;
window.console.warn = log;
window.console.error = log;

console.log("console.log works");
console.warn("console.warn works");
console.error("console.error works");

global = "yes";
log("platform is running! start");

window.SAFARI = true;

//Array.prototype.indexOf = function (obj, fromIndex) {
//  if (fromIndex == null) {
//    fromIndex = 0;
//  } else if (fromIndex < 0) {
//    fromIndex = Math.max(0, this.length + fromIndex);
//  }
//  for (var i = fromIndex, j = this.length; i < j; i++) {
//    if (this[i] === obj) {
//      return i;
//    }
//  }
//  return -1;
//};


Array.prototype.indexOf = function (searchElement /*, fromIndex */ ) {
    "use strict";
    if (this == null) {
        throw new TypeError();
    }
    //  console.log("my indexOf");
    var t = Object(this);
    var len = t.length >>> 0;
    if (len === 0) {
        return -1;
    }
    var n = 0;
    if (arguments.length > 1) {
        n = Number(arguments[1]);
        if (n != n) { // shortcut for verifying if it's NaN
            n = 0;
        } else if (n != 0 && n != Infinity && n != -Infinity) {
            n = (n > 0 || -1) * Math.floor(Math.abs(n));
        }
    }
    if (n >= len) {
        return -1;
    }
    var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
    for (; k < len; k++) {
        if (k in t && t[k] === searchElement) {
            return k;
        }
    }
    return -1;
}

console.log("prototype set at="+(new Date()).valueOf());

try {
  window.Browser =
  {
    handler: null,
    addMessageHandlers: function(obj) {
      for (var i in obj) {
        if(i == "content_textResource") {
          Browser.handler = obj[i];
        }
      }
    },
    sendToExtension: function(obj) {
      try {
        if (!obj) {
          return;
        }
        if(!Browser || obj.href === undefined) {
          return;
        }
        console.log("sendToExtension href="+obj.href);
          JSClipInterface.getResource(obj.href);
      } catch (e){
        console.log("failure in sendToExtension "+e+" \n");
      }
    },
    handleResourceResponse: function(obj) {
      try {
        console.log("handleResourceResponse href"+obj.href);
        //var obj = {href: sheet.href, responseText: text};
        Browser.handler(obj);
        console.log("handleResourceResponse sent to handler href"+obj.href);
      } catch (e){
        console.log("failure in handleResourceResponse "+e+" \n");
      }
    },
    articleReady: function(url) {
        JSClipInterface.articleReady(url);
    }

  };

} catch (e){
  for (var i in e) console.log(i + ": " + e[i]);
  console.log(e);
}
console.log("platform is running! end");
