
//“关于wap页面类型识别的方法
//在中间件内，在多种情况下可能将一个页面视为wap页面，具体包括以下情况：
//1、uri的前缀为m. 3g. wap. 或者 mobi.。具体可以通过wap_uri_prefix配置。
//2、wml类型的页面。
//3、doctype中包含mobile字样的页面，有wap标准规定。
//4、页面内的meta标签具有如下特性：
//通meta标签检测当前文档是否为wap文档
//判断wap文档的条件，以下条件满足一项即认为是wap页面
//1. http-equiv="content-type" content="application/xhtml+xml..."
//2. name="MobileOptimized" content="..."
//3. name="viewport" content="...device-width..." 且不包含 http-equiv=x-ua-compatible content="..."
//4. name="apple-mobile-web-app-capable" content="yes"
//5. name="viewport" content="width="<320""

function hasWapPagePrefix()
{
    var prefixArray = ['m.', '3g.', 'wap.', 'mobi.'];
    var currentUrl = document.location.host;
    for(var i = 0; i < prefixArray.length; ++i)
    {
        if((currentUrl.indexOf(prefixArray[i]) == 0))
        {
            return true;
        }
    }
    return false;
}

function hasWapPageSuffix()
{
    var docTypeArray = ['wml', 'mobile'];
    var docTypeName = document.doctype.name.toLowerCase();
    for(var j = 0; j < docTypeArray.length; ++j)
    {
        if(docTypeName.indexOf(docTypeArray[j]) >= 0)
        {
            return true;
        }
    }
    return false;
}

function hasWapPageMetaInfo()
{
    var isWap = false;
    var metaList = document.getElementsByTagName('meta');
    var len = metaList.length;
    var specialEquiv = false;
    var viewportToWap = false;
    
    for(var k = 0; k < len; ++k)
    {
        var element = metaList[k];
        if(element.httpEquiv.toLowerCase() == 'content-type')
        {
            if(element.content.toLowerCase().indexOf('application/xhtml+xml') >= 0)
            {
                isWap = true;
                break;
            }
            else if(element.content.toLowerCase().indexOf('x-ua-compatible') >= 0)
            {
                specialEquiv = true;
            }
        }
        else if(element.name == 'MobileOptimized')
        {
            isWap = true;
            break;
        }
        else if(element.name == 'apple-mobile-web-app-capable' && element.content=='yes')
        {
            isWap = true;
            break;
        }
        else if(element.name == 'viewport')
        {
            var test = element.content;
            var content = element.content.trim();
            var index = content.trim().lastIndexOf('<');
            
            if(index > 0)
            {
                index=index+1;
                var wide = content.trim().substr(index);
                
                if(parseInt(wide, 10) <= 320)
                {
                    isWap = true;
                    break;
                }
            }
            else if(content.trim().indexOf('device-width') >= 0)
            {
                viewportToWap = true;
            }
        }
    }
    
    if(!isWap && viewportToWap && !specialEquiv)
    {
        isWap = true;
    }
    
    return isWap;
}

function isWapPage()
{
    var isWap = false;// default
    
    try
    {
        isWap = hasWapPagePrefix();
        
        if(!isWap)
        {
            isWap = hasWapPageSuffix();
        }
        
        if(!isWap)
        {
            isWap = hasWapPageMetaInfo();
        }
    }
    catch (e)
    {
    }
    
    return isWap;
}

